Bug 214778 - fs: error in __generic_file_aio_read
fs: error in __generic_file_aio_read
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.4
All Linux
medium Severity medium
: ---
: ---
Assigned To: Larry Woodman
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-11-09 08:59 EST by Monakhov Dmitriy
Modified: 2007-11-16 20:14 EST (History)
1 user (show)

See Also:
Fixed In Version: RHBA-2007-0304
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-05-08 00:04:38 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Backported patch (407 bytes, patch)
2006-11-09 09:01 EST, Monakhov Dmitriy
no flags Details | Diff

  None (edit)
Description Monakhov Dmitriy 2006-11-09 08:59:07 EST
Virtuozzo/OpenVZ Linux Team has noticed an
readv(2) error handling error affected RHEL4 kernels:
Version:2.6.9-42.0.3.EL

readv hits an error during reading, it reports the
error if nothing has been successfully read yet.  This  condition reproducible
when an error occurs, if nothing has been read/written, report the error code;
otherwise, report the amount of bytes successfully transferred up to that
point.
 performing readv(2) with the following iov.

 iov[0] = {len0, ptr1}
 iov[1] = {len1, NULL} (or any other invalid pointer)
 iov[2] = {len2, ptr2}

When file size is enough, performing above readv(2) results in

 len0 bytes from file_pos @ ptr0
 len2 bytes from file_pos + len0 @ ptr2
Expected result:
 len0 bytes from file_pos @ ptr0

It is known issue and it is fixed in mainstream by following patch:
http://kernel.org/git/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff;h=39e88ca2c9d0f6d1e9f34ea2a6e86a652bb69a7a
Comment 1 Monakhov Dmitriy 2006-11-09 09:01:40 EST
Created attachment 140771 [details]
Backported patch
Comment 2 Jason Baron 2006-12-04 14:22:21 EST
committed in stream U5 build 42.28. A test kernel with this patch is available
from http://people.redhat.com/~jbaron/rhel4/
Comment 3 RHEL Product and Program Management 2006-12-14 17:46:48 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 4 Jay Turner 2006-12-18 09:54:27 EST
QE ack for RHEL4.5.
Comment 7 Red Hat Bugzilla 2007-05-08 00:04:38 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2007-0304.html

Note You need to log in before you can comment on or make changes to this bug.